__author__ = "Neil Muller"
__copyright__ = "Copyright (c) 2007 Neil Muller"
__license__ = "MIT-style"

"""
Hello world (purely) in pygame, with a bouncing ball sprite
"""

import pygame
import sys, os

pygame.init()
pygame.display.init()
try:
    pygame.font.init()
except Exception, e:
    print "Unable to initialise font module"
    print e
    sys.exit()

tSize=(800,600)
oScreen=pygame.display.set_mode(tSize)
pygame.display.set_caption("Hello World")
oScreen=pygame.display.get_surface()
oBackground=oScreen.copy()
oBackRect=oBackground.get_rect()

oFont=pygame.font.Font(None,90)
oText=oFont.render('Hello World!',True,(128, 128, 128))
oBackground.blit(oText,(5,5))
oScreen.blit(oBackground,(0,0))
pygame.display.update()

name=os.path.join('images','blue_circ_24bit.png')
oBallImage=pygame.image.load(name).convert_alpha()
oBallRect=oBallImage.get_rect(centerx=oScreen.get_width()/2,
                       centery=oScreen.get_height()/2)
oBallSprite=pygame.sprite.Sprite()
oBallSprite.image=oBallImage
oBallSprite.rect=oBallRect
oGroup=pygame.sprite.RenderUpdates()
oGroup.add(oBallSprite)

oSideWalls=pygame.sprite.AbstractGroup()
oTopBotWalls=pygame.sprite.AbstractGroup()
LeftWall=pygame.sprite.Sprite()
LeftWall.rect=pygame.Rect((-10,0,10,tSize[1]))

RightWall=pygame.sprite.Sprite()
RightWall.rect=pygame.Rect((tSize[0],0,10,tSize[1]))

oSideWalls.add((LeftWall,RightWall))

TopWall=pygame.sprite.Sprite()
TopWall.rect=pygame.Rect((0,-10,tSize[0],10))

BottomWall=pygame.sprite.Sprite()
BottomWall.rect=pygame.Rect((0,tSize[1],tSize[0],10))

oTopBotWalls.add((TopWall,BottomWall))

pygame.display.update(oGroup.draw(oScreen))
aVelocity=[1,1]
oClock=pygame.time.Clock()

while True:
    oClock.tick(70)
    event=pygame.event.poll()
    if event.type == pygame.QUIT:
         sys.exit()
    elif event.type == pygame.KEYUP and event.key == pygame.K_q:
         sys.exit()
    oBallSprite.rect.move_ip(aVelocity[0],aVelocity[1])
    if pygame.sprite.spritecollideany(oBallSprite,oTopBotWalls) is not None:
        aVelocity[1]=-aVelocity[1]
    if pygame.sprite.spritecollideany(oBallSprite,oSideWalls) is not None:
        aVelocity[0]=-aVelocity[0]
    oGroup.clear(oScreen,oBackground)
    pygame.display.update(oGroup.draw(oScreen))
